// Copyright (c) 2007-2012  Michael Chapman
// http://ipaddresscontrollib.googlecode.com

// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:

// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.

// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
// TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.Management;
using System.Net;
using System.Net.Sockets;
using System.Threading;

namespace UdpJoystickMonitor
{
    public partial class Form1 : Form
    {
        // ϐ̐錾
        ManagementObjectSearcher mos;
        ManagementObjectCollection moc;
        String strIPAddress;
        IPAddress ipaddress;
        Socket udpSocket = null;
        int x, y;
        public Thread udpThread;
        byte[] byteData = new byte[42];

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // gIPAhX擾邽߂̏
        	// Win32_NetworkAdapterConfigurationNXɃANZXIPAhX̏擾
            mos = new ManagementObjectSearcher("SELECT * FROM Win32_NetworkAdapterConfiguration WHERE IPEnabled=TRUE");
            moc = mos.Get();

            foreach (ManagementObject mo in moc)
            {
                if ((bool)mo.Properties["IPEnabled"].Value == true)
                {
                    strIPAddress = ((string[])mo.Properties["IPAddress"].Value)[0];
                }
            }
            // 擾IPAhX̕IPAddressIuWFNgɕϊ
            ipaddress = IPAddress.Parse(strIPAddress);
        	
            // IPAddressRg[Ɏ擾IPAhX̒lZbg
            ipAddressControl.SetAddressBytes(ipaddress.GetAddressBytes());

			// [Stop]{^񊈐ɂ
            btnStop.Enabled = false;
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            CheckForIllegalCrossThreadCalls = false;

            //udpSocket̃IuWFNg쐬
            udpSocket = new Socket(AddressFamily.InterNetwork,
                SocketType.Dgram, ProtocolType.Udp);

	        // ׂĂIPAhX, 55555ԃ|[gIPEndPoint쐬
        	// ǂ̃AhX蓖ĂĂĂ܂Ȃꍇ́AIPAddress.Anygp
        	// IPEndPoint́AIPAhXƃ|[gԍZbgɂĈIuWFNg
            IPEndPoint ipEndPoint = new IPEndPoint(IPAddress.Any, 55555);

            // قǍ쐬 IPEndpointoCh
            udpSocket.Bind(ipEndPoint);

			// gp郍[JE|[gɂēɎw肪Ȃꍇ̓|[gԍ0w肷
        	// gpł|[gԍŊ蓖ĂĂ
            IPEndPoint ipeRemote = new IPEndPoint(IPAddress.Any, 0);
            EndPoint epRemote = (EndPoint)ipeRemote;

            // f[^̔񓯊M̊Jn
            udpSocket.BeginReceiveFrom(byteData, 0, byteData.Length,
                SocketFlags.None, ref epRemote, new AsyncCallback(ReceiveCall), epRemote);

			// [Start]{^񊈐A[Stop]{^ɂ
            btnStart.Enabled = false;
            btnStop.Enabled = true;
        }

        private void btnStop_Click(object sender, EventArgs e)
        {
        	// udpSocket
            udpSocket.Close();
            // [Start]{^A[Stop]{^񊈐ɂ
            btnStart.Enabled = true;
            btnStop.Enabled = false;
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
        
            if ( udpSocket !=null )
                udpSocket.Close();
            // vȌI    
            Application.Exit();
        }

        private void ReceiveCall(IAsyncResult ar)
        {
            try
            {
                IPEndPoint ipeRemote = new IPEndPoint(IPAddress.Any, 0);
                EndPoint epRemote = (EndPoint)ipeRemote;

				// ۗ̔񓯊ǂݍ݂̏I
                udpSocket.EndReceiveFrom(ar, ref epRemote);
                
                // f[^̔񓯊M̊Jn
                udpSocket.BeginReceiveFrom(byteData, 0, byteData.Length, SocketFlags.None, ref epRemote,
                        new AsyncCallback(ReceiveCall), epRemote);

                string str = System.Text.Encoding.Unicode.GetString(byteData);
                
                // ,(J})ŋ؂ꂽf[^𕪊ĔzɊi[
                string[] arrayData = Encoding.UTF8.GetString(byteData).ToString().Split(',');

                // f[^̑MIPAhXуWCXeBbÑf[^\
                labelIPAddr.Text = arrayData[0];
                labelCnt.Text = arrayData[1];
                labelUD.Text = arrayData[2];
                arrayData[2] = arrayData[3].Replace("\0", "");
                labelLR.Text = arrayData[3];
                x = (int)(float.Parse(arrayData[1]) * 10);
                y = (int)(float.Parse(arrayData[2].Trim()) * 10);

            }
            catch (Exception ex)
            {
                // String strErrMsg = string.Format("{0}", ex);
                //  MessageBox.Show(strErrMsg, "Exception caught", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
    }
}
